Lua_AllEntranceWindow = class("Lua_AllEntranceWindow", Lua_Window)
function Lua_AllEntranceWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AllEntranceWindow";
	self.skinName = "AllEntranceWindow_skin";
end

function Lua_AllEntranceWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.list = Array();
	self.list:add({ label = "GC", owner = self, fun = self.onGcClick });
	self.list:add({ label = "提示测试", owner = self, fun = self.tipsTest });
	self.list:add({ label = "指引", owner = self, fun = self.GuideOrderFun });

	self.list:add({ label = "欢迎界面", windowName = "Lua_WelcomeWindow" });
	self.list:add({ label = "PVE死亡", windowName = "Lua_PlayerDeadWindow" });
	self.list:add({ label = "PVP死亡", windowName = "Lua_ReviveCountDownWindow", param = {config = {wait = 15, test = true}} });
	self.list:add({ label = "等级提升", windowName = "Lua_RoleLevelUpTips", param = {}});
	self.list:add({ label = "获得新称号", windowName = "Lua_GetTitleWindow", param = {label_id = 1000087} });
	self.list:add({ label = "成就达成", windowName = "Lua_AchievementGetWindow" });
	self.list:add({ label = "社团任务捐献", windowName = "Lua_SubmitEquToFactionWindow", param = {quality = 1, grade = 1} });
	
	self.list:add({ label = "交易", windowName = "Lua_TransactionWindow" });
	self.list:add({ label = "vip礼包", windowName = "Lua_SuperVipGiftWindow" });

	self.list:add({ label = "副本减速", windowName = "Lua_CopyJianSuWindow" });
	self.list:add({ label = "聚魂转盘", windowName = "Lua_JuHunZhuanPanWindow" });

	self.list:add({ label = "跨服3v3副本", windowName = "Lua_FightInfoShowWindow" });
	self.list:add({ label = "3v3结束", windowName = "Lua_KuaFuFightEndWindow" });
	self.list:add({ label = "3V3组队申请", windowName = "Lua_KuaFuTeamCommiteWindow" });
	self.list:add({ label = "3V3死亡", windowName = "Lua_KuaFuDeathWindow" });
	
	self.list:add({ label = "精灵续费", windowName = "Lua_FairyExpireWindow" });
	self.list:add({ label = "精灵过期", windowName = "Lua_FairySceneTipWindow" });
	self.list:add({ label = "体验版精灵Tips", windowName = "Lua_FairyTipsWindow",
		param = {type = 1, fairyData = {toolVo = Lua_ToolVo.createToolVo(207100103),
			name = Lua_ToolVo.createToolVo(207100103).name}} });

	self.list:add({ label = "婚宴预约", windowName = "Lua_MarryYuYueWindow" });
	self.list:add({ label = "前往结婚", windowName = "Lua_MarryWindow" });
	self.list:add({ label = "求婚界面", windowName = "Lua_MarryTipsWindow" });
	self.list:add({ label = "婚宴选择", windowName = "Lua_MarrySelectedWindow" });
	self.list:add({ label = "补办婚宴选择", windowName = "Lua_WeddingBanquetWindow" });
	self.list:add({ label = "婚宴咨询", windowName = "Lua_MarryInfoWindow" });
	self.list:add({ label = "解除关系", windowName = "Lua_MarryBrokenWindow" });
	self.list:add({ label = "解除关系确认", windowName = "Lua_BreakMarryTipsWindow" });
	self.list:add({ label = "婚宴信息栏", windowName = "Lua_MarryMainWindow" });
	self.list:add({ label = "宾客名单", windowName = "Lua_MarryVisitorWindow" });
	self.list:add({ label = "婚宴预告", windowName = "Lua_MarryYuGaoWindow" });
	self.list:add({ label = "邀请函", windowName = "Lua_MarryYaoQingWindow" });
	self.list:add({ label = "婚宴信息", windowName = "Lua_YaoQingHanWindow" });
	self.list:add({ label = "婚宴商店", windowName = "Lua_MarryShopWindow" });
	
	self.list:add({ label = "图标功能开启", windowName = "Lua_FuncOpenTipsPanel" });
	self.list:add({ label = "模型功能开启", windowName = "Lua_FuncOpenModelPanel", param = {id = 10117, param = getConfig({"func_open", 10117})} }); -- 功能开启id
	self.list:add({ label = "外观侍宠模型", windowName = "Lua_NewFeatureDisplayWindow", param = {winType = 1, panelIndex = 1, featureData = DataCenter.servantData, modelType = 1} });
	self.list:add({ label = "新觉醒形态", windowName = "Lua_OpenSeventDayModelPanel", param = {} }); -- 先点击觉醒界面，再点击这个按钮
	self.list:add({ label = "获得新技能", windowName = "Lua_SkillActiveTipsWindow" });
	
	self.list:add({ label = "运镖入口", windowName = "Lua_YunBiaoWindow" });
	self.list:add({ label = "运镖对话框", windowName = "Lua_FinishYunBiaoWindow" });
	
	self.list:add({ label = "非滚动广告", windowName = "Lua_BulletinBoardSecWindow", param = {circle = 1, content = "非滚动广告非滚动广告非滚动广告", display_horn = 1} });
	self.list:add({ label = "滚动广告", windowName = "Lua_BulletinBoardWindow", param = {circle = 1, content = "滚动广告滚动广告滚动广告滚动广告滚动广告滚动广告"} });
	self.list:add({ label = "非滚动喇叭", windowName = "Lua_LaBaSecWindow", param = {circle = 1, content = "非滚动喇叭非滚动喇叭非滚动喇叭"} });
	self.list:add({ label = "滚动喇叭", windowName = "Lua_LaBaWindow", param = {circle = 1, content = "滚动喇叭滚动喇叭滚动喇叭滚动喇叭滚动喇叭滚动喇叭"} });

	self.list:add({ label = "限时BOSS", windowName = "Lua_LimitTimeBossRageWindow" });
	self.list:add({ label = "天雷倒计时", windowName = "Lua_ThurderCountWindow", param = {leftTime = getTime() + 15} });
	self.list:add({ label = "天雷处罚", windowName = "Lua_ThunderStrikeWindow" });
	self.list:add({ label = "天雷测试", owner = self, fun = self.onThunderStrikeTest });
	self.list:add({ label = "天降豪礼", windowName = "Lua_GiftActivitiesWindow" });

	self.list:add({ label = "运营活动", windowName = "Lua_OperationalActivitiesWindow" });
	self.list:add({ label = "招财猫", windowName = "Lua_FortuneCatWindow" });
	self.list:add({ label = "神秘限购", windowName = "Lua_MysteriousBuyWindow" });
	self.list:add({ label = "盘古开天", windowName = "Lua_PanGuWindow" });
	self.list:add({ label = "天选之战", windowName = "Lua_TheSelectionWarWindow" });
	self.list:add({ label = "开服冲榜", windowName = "Lua_NewServerActivityWindow" });
	self.list:add({ label = "盛典活动", windowName = "Lua_GrandCeremonyWindow" });
	self.list:add({ label = "水晶之战", windowName = "Lua_CrystalWarWindow" });
	self.list:add({ label = "迷宫寻宝", windowName = "Lua_MazeHuntWindow" });
	self.list:add({ label = "天天返利", windowName = "Lua_DailyRebateWindow" });
	self.list:add({ label = "跨服充值排行", windowName = "Lua_CrossServerRechargeWindow" });
	self.list:add({ label = "跨服云购", windowName = "Lua_CrossServerPurchasingWindow" });
	self.list:add({ label = "魅力之王", windowName = "Lua_CharmKingWindow" });
	self.list:add({ label = "元宝大翻倍", windowName = "Lua_YuanBaoDoubleWindow" });
	self.list:add({ label = "外观特卖", windowName = "Lua_SpecialofferWindow" });
	self.list:add({ label = "0元抢购", windowName = "Lua_PurchaseWindow" });
	self.list:add({ label = "0元礼包", windowName = "Lua_GiftsWindow" });
	self.list:add({ label = "新0元礼包", windowName = "Lua_NewZeroGiftWindow" });
	self.list:add({ label = "每日充值", windowName = "Lua_ChargeEverydayWindow" });
	self.list:add({ label = "新每日充值", windowName = "Lua_NewChargeEverydayWindow" });
	self.list:add({ label = "每日消费", windowName = "Lua_DailyConsumptionWindow" });

	self.list:add({ label = "重连中界面", windowName = "Lua_ReconnectingWindow" });
	self.list:add({ label = "重连提示界面", windowName = "Lua_ReconnectWindow" });
	self.list:add({ label = "首充tips界面", windowName = "Lua_FristRechargeTipsWindow" });

	self.list:add({ label = "ios提审充值", windowName = "Lua_ChongzhiIosWindow" });
	self.list:add({ label = "测试信息", windowName = "Lua_TestWindow" });

	local px;
	local py;
	local btn;
	self.btnList = Array();
	local len = self.list:getSize();
	for i = 1, len do
		px = -490 + ((i - 1) % 8) * 140 ;
		py = 220 - math.floor((i - 1) / 8) * 50;
		btn = UICreate.createButton(self.content, self.list[i].label, px, py, 120, 40);
		btn.name = i;
		btn:setDepth(5);
		btn:setStyle(29);
		if self.list[i].owner ~= nil and self.list[i].fun ~= nil then
			btn:addClickFuntion(self.list[i].owner, self.list[i].fun);
		else
			btn:addClickFuntion(self, self.onOpenWindow);
		end
		self.btnList:add(btn);
	end
end

function Lua_AllEntranceWindow:tipsTest()
	-- Lua_WindowUtil.openWin("Lua_SubmitEquToFactionWindow", WinParam.ACTION_OPEN, {quality = 1, grade = 1});
	-- OperateAlert.show("number "..math.random(1, 100));

	-- Lua_MsgUtil.callFunc("SET_MAIN_MENU", 1);

	-- Lua_WindowUtil.openWin("Lua_ModelFloatingWindow", WinParam.ACTION_OPEN, {id=10008,param = getConfig({"func_open", 10008})});
	-- Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN, Lua_BossData.BOSS_NAME_2_INDEX[LanUtil.getValue(121601)]);
	
	-- local dis = Vector3.Distance(Vector3(5620, 736, 7233), Vector3(5459, 742, 7272));
	-- print("test Distance:", dis);

	-- Lua_MsgUtil.callFunc("OPEN_GAMEPLAY_UI",2);

	-- local sceneCfg = Lua_SceneConfigData.getSceneConfig(20301);
	-- print("sceneCfg", sceneCfg.config.quit_to_guide);

	Lua_WindowUtil.openWin("Lua_PersonalBossCopyInfoWindow", WinParam.ACTION_OPEN);
end

function Lua_AllEntranceWindow:GuideOrderFun()
	Lua_WindowUtil.openWin("Lua_GuideOrderWindow", WinParam.ACTION_OPEN);
	self:hide();
end

function Lua_AllEntranceWindow:onThunderStrikeTest()
	-- Lua_WindowUtil.openWin("Lua_ThunderStrikeWindow", WinParam.ACTION_OPEN, 10);
	-- Lua_WindowUtil.openWin("Lua_CountDownWindow", WinParam.ACTION_OPEN, {cbOwner = self, showText = "剩余时间：{1}", leftTime = 10, cbFun = self.onCountDownFinish, cbFunParam = "finish countdown"});

	-- local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
	-- if rolePlayer ~= nil then
	-- 	rolePlayer:onPlayThunderStrikeEffect();
	-- end

	Lua_MsgUtil.callFunc("TOPRIGHT_REMOVE_ICON", 10001);
	-- Lua_MsgUtil.callFunc("TOPRIGHT_ADD_ICON", 10001);
end

function Lua_AllEntranceWindow:onCountDownFinish(val)
	print(val);
end

function Lua_AllEntranceWindow:onGcClick(go)
	CommonUtil.clearMemory();
end

function Lua_AllEntranceWindow:onOpenWindow(go)
	local item = self.list[tonumber(go.name)];
	Lua_WindowUtil.openWin(item.windowName, nil, item.param);
	self:hide();
end