Lua_DebugCameraWindow = class("Lua_DebugCameraWindow", Lua_Window);
function Lua_DebugCameraWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_DebugCameraWindow";
	self.skinName = "DebugCameraWindow_skin";
	self.showBg = false;
	self.isModel = false;
end

function Lua_DebugCameraWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.startX = CameraControl.Instance:getCamAngleX();

	self.posXBar:createSlider("common_atlas_1","ui_common_xing_01");
	self.posXBar:addSlidingFun(self, self.onPosxSliding);
	self.posXBar:setMaxValue(100);
	self.posXBar:setValue(50);
	self.posXBar:setText("");
	self:setPosX(50);

	self.posYBar:createSlider("common_atlas_1","ui_common_xing_01");
	self.posYBar:addSlidingFun(self, self.onPosySliding);
	self.posYBar:setMaxValue(100);
	self.posYBar:setValue(50);
	self.posYBar:setText("");
	self:setPosY(50);

	self.posZBar:createSlider("common_atlas_1","ui_common_xing_01");
	self.posZBar:addSlidingFun(self, self.onPoszSliding);
	self.posZBar:setMaxValue(100);
	self.posZBar:setValue(50);
	self.posZBar:setText("");
	self:setPosZ(50);

	self.angleX:createSlider("common_atlas_1","ui_common_xing_01");
	self.angleX:addSlidingFun(self, self.onAngleXSliding);
	self.angleX:setMaxValue(100);
	self.angleX:setValue(50);
	self.angleX:setText("");
end

function Lua_DebugCameraWindow:onPosxSliding(val)
	self:setPosX(val);
end

function Lua_DebugCameraWindow:setPosX(val)
	local v = -10 + val * 20 / 100;
	self.posXTxt.text = v;
	MsgUtil.callFunc("CAM_MOVE_X", v);
end

function Lua_DebugCameraWindow:onPosySliding(val)
	self:setPosY(val);
end

function Lua_DebugCameraWindow:setPosY(val)
	local v = -10 + val * 20 / 100;
	self.posYTxt.text = v;
	MsgUtil.callFunc("CAM_MOVE_Y", v);
end

function Lua_DebugCameraWindow:onPoszSliding(val)
	self:setPosZ(val);
end

function Lua_DebugCameraWindow:setPosZ(val)
	local v = -10 + val * 20 / 100;
	self.posZTxt.text = v;
	MsgUtil.callFunc("CAM_MOVE_Z", v);
end

function Lua_DebugCameraWindow:onAngleXSliding(val)
	self:setAngle(val);
end

function Lua_DebugCameraWindow:setAngle(val)
	local v = self.startX - 30 + val * 60 / 100;
	self.angleXTxt.text = v;
	MsgUtil.callFunc("CAM_ANGLE_X", v);
end

function Lua_DebugCameraWindow:dispose()
	MsgUtil.callFunc("CAM_MOVE_X", 0);
	MsgUtil.callFunc("CAM_MOVE_Y", 0);
	MsgUtil.callFunc("CAM_MOVE_Z", 0);
	MsgUtil.callFunc("CAM_ANGLE_X", self.startX);
	self:superCall("dispose");
end