Lua_DebugDistanceWindow = class("Lua_DebugDistanceWindow", Lua_Window);
function Lua_DebugDistanceWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_DebugDistanceWindow";
	self.skinName = "DebugDistanceWindow_skin";
	self.isModel = false;
end

function Lua_DebugDistanceWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addCSharpEvent("START_POINT", self, self.onStartPos);
	self:addCSharpEvent("END_POINT", self, self.onEndPos);
	self:addCSharpEvent("POINT_DIS", self, self.onPointDis);

	self.posXBar:createSlider("common_atlas_1","ui_common_xing_01");
	self.posXBar:addSlidingFun(self, self.onPosxSliding);
	self.posXBar:setMaxValue(2000);
	self.posXBar:setValue(100);
	self.posXBar:setText("");
	
	self:setPosX(100);

	self.box:addBoxChange(self,self.onCircleClick);

	MsgUtil.callFunc("CHECK_DIS", true);
end

function Lua_DebugDistanceWindow:onStartPos(val)
	self.startTxt.text = val;
end

function Lua_DebugDistanceWindow:onEndPos(val)
	self.endTxt.text = val;
end

function Lua_DebugDistanceWindow:onPointDis(val)
	self.disTxt.text = val;
end

function Lua_DebugDistanceWindow:onCircleClick(state)
	MsgUtil.callFunc("SHOW_CIRCLE", state);
end

function Lua_DebugDistanceWindow:onPosxSliding(val)
	self:setPosX(val);
end

function Lua_DebugDistanceWindow:setPosX(val)
	MsgUtil.callFunc("CIRCLE_CHANGE", val);
	self.posXTxt.text = val;
end

function Lua_DebugDistanceWindow:dispose()
	MsgUtil.callFunc("CHECK_DIS", false);
	self:superCall("dispose");
end