checkRequire("Lua_DebugOutPutData");
Lua_DebugOutputPanel = class("DebugOutputPanel", Lua_DisplayObject);
function Lua_DebugOutputPanel:ctor(p)
	self.showMsg = 0;
	self.index = 0;
	if Lua_DebugOutputPanel.outData == nil then
		Lua_DebugOutputPanel.outData = Lua_DebugOutPutData.new();
	end
	self:superCall("ctor", p, "DebugOutputPanel_skin");
end

function Lua_DebugOutputPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.txtInput.defaultText = "请输入消息号";

	self.textArea = Lua_TextArea.new(self.content, 350, 180);
	self.textArea:setLocation(-175, 95, 0);
	self.textArea:setText("info");

	self.startBox.seleted = Lua_DebugOutputPanel.outData:isStart();
	self.startBox:addBoxChange(self, self.onStartBoxClick);
	self.copyBtn:addClickFuntion(self, self.onCopyClick);
	self.clearBtn:addClickFuntion(self, self.onClearClick);
	self.guolvBtn:addClickFuntion(self, self.onGuoLvClick);

	self:updateTextArea();
	self:addLuaEvent("NEW_MSG_TRACE", self, self.updateTextArea);
end

function Lua_DebugOutputPanel:updateTextArea()
	self.str = "";
	local msgList = Lua_DebugOutputPanel.outData.msgList;
	if msgList == nil then
		self.textArea:setText(self.str);
		return;
	end

	for i = 1, msgList:getSize() do
		if self.showMsg == 0 or self.showMsg == msgList[i].id then
			self.str = self.str .. msgList[i].id .. "  err：" .. msgList[i].err ..
				"  index：" .. self.index .. "\nmsg：" .. msgList[i].data .. "\n";
		end
	end
	self.textArea:setText(self.str);
end

function Lua_DebugOutputPanel:onStartBoxClick(state)
	if Lua_DebugOutputPanel.outData:isStart() == false then
		Lua_DebugOutputPanel.outData:startListen();
	else
		Lua_DebugOutputPanel.outData:endListen();
	end
end

function Lua_DebugOutputPanel:onCopyClick(go)
	LanUtil.copyToClipboard(self.str);
end

function Lua_DebugOutputPanel:onClearClick(go)
	local msgList = Lua_DebugOutputPanel.outData.msgList;
	if msgList ~= nil then
		msgList:clear();
		self:updateTextArea();
	end
end

function Lua_DebugOutputPanel:onGuoLvClick(go)
	self.showMsg = tonumber(self.txtInput.text);
	self:updateTextArea();
end