checkRequire("Lua_DebugOutputPanel");
checkRequire("Lua_TouchControler");
Lua_DebugWindow  = class("Lua_DebugWindow" , Lua_Window)
function Lua_DebugWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_DebugWindow";
	self.skinName = "DebugWindow_skin";
	self.isModel = false;
	self.showClose = false;
	self.layer = 3500;
end

function Lua_DebugWindow:buildShowItem()
	self:superCall("buildShowItem");

	self._isClick = false;
	
	-- 点击移动面板
	self.titleNameBg.clickScale = false;
	self.titleNameBg:addClickFuntion(self, self.onMouseDownHandle);
	self.titleNameBg:addMouseUpFuntion(self, self.onMouseUpHandle);

	-- self.p1 = Vector2(0, 0);
	-- self.p2 = Vector2(100, 0);
	-- self.p3 = Vector2(100, -100);
	-- self.p4 = Vector2(0, -100);

	-- self.maskBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_zhezhao", 0, 0, 1280, 720);
	-- self.maskBg.name = "maskBg"；
	-- self.maskBg:setDepth(-1);
	-- self.maskBg:addClickFuntion(self, self.onBgMouseDownHandle);

	self.outPutPanel = Lua_DebugOutputPanel.new(self.content);
	self.outPutPanel:setLocation(0, -145, 0);
	self.outPutPanel:setEnable(false);
	self.outPanelState = false;

	self.list = Array();
	-- self.list:add({ label = "取UI路径", owner = self, fun = self.onUIPathPrint});
	self.list:add({ label  = "GC_T", owner = self, fun = self.onGcClick });
	self.list:add({ label = "摄像机参数", owner = self, fun = self.onCameraInfoClick });
	self.list:add({ label = "消息号打印", owner = self, fun = self.onMsgOutClick });
	self.list:add({ label = "相机1", owner = self, fun = self.onCamera1Click });
	self.list:add({ label = "距离", owner = self, fun = self.onDistanceClick });
	self.list:add({ label = "指引名字", owner = self, fun = self.onZhiYinName });
	self.list:add({ label = "颜色转换", owner = self, fun = self.onColorChange });
	self.list:add({ label = "系统播报", owner = self, fun = self.onTestLaBa });
	self.list:add({ label = "灵纹类型", owner = self, fun = self.onRunesOpenType });
	self.list:add({ label = "移动打印", owner = self, fun = self.printSelfMove });
	self.list:add({ label = "开启功能", owner = self, fun = self.openAllFunc });
	self.list:add({ label = "[00E125]开关任务挂机[-]", owner = self, fun = self.switchTaskHook });
	self.list:add({ label = "挂机打印", owner = self, fun = self.hookPrint });
	self.list:add({ label = "包信息", owner = self, fun = self.onPackageInfo });
	self.list:add({ label = "[00E125]刷新Lua[-]", owner = self, fun = self.updateLuaFile });

	local px;
	local py;
	local btn;
	self.btnList = Array();
	for i = 1, self.list:getSize() do
		px = -145 + ((i - 1) % 3) * 145;
		py = -60 * math.floor((i - 1) / 3);
		btn = UICreate.createButton(self.content, self.list[i].label, px, py, 120, 40);
		btn.name = "btn"..i;
		btn:setDepth(5);
		btn:setStyle(29);
		btn:addClickFuntion(self.list[i].owner, self.list[i].fun);
		self.btnList:add(btn);
	end

	self.moveCbox.seleted = DataCenter.moveTest;
	self.mapCbox.seleted = DataCenter.mapMesh;

	self.sendBtn:addClickFuntion(self, self.onSendClick);
	self.moveCbox:addBoxChange(self, self.onMoveBoxClick);
	self.mapCbox:addBoxChange(self, self.onMapBoxClick);

	self:addLuaEvent("TOUCH_CHANGE", self, self.onTouchChange);
end

function Lua_DebugWindow:switchTaskHook()
	DataCenter.taskHook:opencloseHook(not DataCenter.taskHook.openning);
	-- Lua_WindowUtil.openWin("Lua_NeedDoNowWindow",WinParam.ACTION_OPEN);
	-- print("haha",string.format("%.1f", 4.43));
end

function Lua_DebugWindow:onBgMouseDownHandle(go, state)
	local v = Vector3(UnityEngine.Input.mousePosition.x, UnityEngine.Input.mousePosition.y, 0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.content.transform:InverseTransformPoint(screenpos);
	print("mousePosition.x = ", mousePosition.x, "mousePosition.y = ", mousePosition.y, "isPointInMatrix = ", self:isPointInMatrix(mousePosition));
end

function Lua_DebugWindow:getCross(v1, v2, v)
	return (v2.x - v1.x) * (v.y - v1.y) - (v.x - v1.x) * (v2.y - v1.y);
end

function Lua_DebugWindow:isPointInMatrix(v)
	return self:getCross(self.p1, self.p2, v) * self:getCross(self.p3, self.p4, v) >= 0 and
	self:getCross(self.p2, self.p3, v) * self:getCross(self.p4, self.p1, v) >= 0;
end

function Lua_DebugWindow:printSelfMove()
	Lua_WindowUtil.openWin("Lua_MoveTestWindow",WinParam.ACTION_OPEN);
end

function Lua_DebugWindow:hookPrint()
	GlobalVar.no_tips = true;
end

function Lua_DebugWindow:onUIPathPrint()
	-- local uic = ContainerUtil.getConainer("uiContainer");
	-- local bc = uic:AddComponent(typeof(BoxCollider));
	-- bc.isTrigger = true;
	-- bc.center = Vector3(0, 0, 0);
	-- bc.size = Vector3(1500, 1000, 0);
end

function Lua_DebugWindow:onMouseDownHandle(go, state)
	self:onPress(go, true);
end

function Lua_DebugWindow:onMouseUpHandle(go, state)
	self:onPress(go, false);
end

function Lua_DebugWindow:onPress(go, state)
	if state == true then
		if self._isClick == nil or self._isClick == false then
			self._isClick = true;
			self.startMouseX = UnityEngine.Input.mousePosition.x;
			self.startMouseY = UnityEngine.Input.mousePosition.y;
			Lua_CommonUtil.addTimer("Lua_DebugWindow", 0.01, self, self.onDebugDragFrame);
		end   
	else
		if self._isClick ~= nil and self._isClick == true then
			self._isClick = false;
			Lua_CommonUtil.removeTimer(self, self.onDebugDragFrame);
		end
	end
end

function Lua_DebugWindow:onDebugDragFrame()
	local dx = UnityEngine.Input.mousePosition.x - self.startMouseX;
	local dy = UnityEngine.Input.mousePosition.y - self.startMouseY;
	self.startMouseX = UnityEngine.Input.mousePosition.x;
	self.startMouseY = UnityEngine.Input.mousePosition.y;

	local endPosX = (MainWinDefine.V_width - self.winBg.width) / 2;
	local maxPosY = (MainWinDefine.V_height - self.winBg.height) / 2;
	local minPoxY = MainWinDefine.V_height - 330;
	local vec = self.content.transform.localPosition;
	local targetX = vec.x + dx;
	local targetY = vec.y + dy;
	if targetX < -endPosX or targetX > endPosX or targetY < -minPoxY or targetY > maxPosY then
		return;
	end
	LuaUtil.setObjPos(self.content, targetX, targetY, vec.z);
end

function Lua_DebugWindow:openAllFunc()
	DataCenter.funcOpenData:openAll();
end

function Lua_DebugWindow:onPackageInfo()
	OperateAlert.show("包号:"..getPackName().."   渠道:"..getAgentName());
end

function Lua_DebugWindow:onSendClick(go)
	local arr = string.split(self.msgInput.text," ");
	if arr[1] == "guide" then
		Lua_WindowUtil.openWin("Lua_GuideWindow", nil, tonumber(arr[2]));
		return;
	elseif arr[1] =="testMove" then
		if DataCenter.testMove == nil then
			DataCenter.testMove = true;
		else
			DataCenter.testMove = not DataCenter.testMove;
		end
	elseif arr[1] =="shadowOn" then
		MsgUtil.callFunc("SHADOW_ON", tonumber(arr[2]));
	elseif arr[1] =="shadowOff" then
		MsgUtil.callFunc("SHADOW_OFF");
	elseif arr[1] == "openAll" then
		DataCenter.funcOpenData:openAll();
	elseif arr[1] == "act" then
		ActingManager.getInstance():startAct(tonumber(arr[2]));
	elseif arr[1] == "package" then
		DataCenter.rechargeData.testPackageId = arr[2];
		return;
	end

	local len = arr:getSize();
	local msg = ProtoPublic_pb.Proto11499999();
	msg.cmd_name = arr[1];
	if len > 1 then
		msg.param1 = tonumber(arr[2]);
	end
	if len > 2 then
		msg.param2 = tonumber(arr[3]);
	end
	if len > 3 then
		msg.param3 = tonumber(arr[4]);
	end
	if len > 4 then
		msg.param4 = tonumber(arr[5]);
	end
	if len > 5 then
		msg.param5 = tonumber(arr[6]);
	end
	sendMsg(11499999, msg);
end

function Lua_DebugWindow:onMoveBoxClick(state)
	DataCenter.moveTest = state;
end

function Lua_DebugWindow:onMapBoxClick(state)
	DataCenter.mapMesh = state;
	MsgUtil.callFunc("SHOW_MAP_MESH");
end

function Lua_DebugWindow:onGcClick(go)
	-- LuaGC();
	Lua_TouchControler.getInstance():startTouchCheck();
end

function Lua_DebugWindow:onTouchChange(val)
	OperateAlert.show("onTouchChange"..val);
end

function Lua_DebugWindow:onSaveLuaData(go)
	CommonUtil.clearMemory();
	saveDebugLuaDatas();
end

function Lua_DebugWindow:onCameraInfoClick(go)
	MsgUtil.callFunc("SHOW_CAM_INFO");
end

function Lua_DebugWindow:onCamera1Click(go)
	Lua_WindowUtil.openWin("Lua_DebugCameraWindow");
end

function Lua_DebugWindow:onDistanceClick(go)
	Lua_WindowUtil.openWin("Lua_DebugDistanceWindow");
end

function Lua_DebugWindow:onZhiYinName(go)
	Lua_WindowUtil.openWin("Lua_DebugItemNameWindow");
end

function Lua_DebugWindow:onMsgOutClick(go)
	self.outPanelState = not self.outPanelState;
	self.outPutPanel:setEnable(self.outPanelState);
	self:updateWindowDepth();
end

function Lua_DebugWindow:onWaterWave()
	-- if self.wwe == 1 then
	-- 	self.wwe = 0;
	-- 	MsgUtil.callFunc("REMOVE_POST_EFFECT", 2);
	-- else
	-- 	self.wwe = 1;
	-- 	MsgUtil.callFunc("ADD_POST_EFFECT", 2);
	-- end
end

function Lua_DebugWindow:onRadialBlur()
	-- if self.rbe == 1 then
	-- 	self.rbe = 0;
	-- 	MsgUtil.callFunc("REMOVE_POST_EFFECT", 1);
	-- else
	-- 	self.rbe = 1;
	-- 	MsgUtil.callFunc("ADD_POST_EFFECT", 1);
	-- end
end

function Lua_DebugWindow:onColorChange(go)
	local str = self.msgInput.text;
	if str == nil or str == "" then
		return;
	end
	print(Lua_ColorDefine.transColor(str));
end

function Lua_DebugWindow:onRunesOpenType(go)
	local str = "";
	local arr = DataCenter.runeData.unLockType;
	if arr ~= nil then
		local len = #arr;
		for i = 1, len do
			str = str..arr[i];
			if i < len then
				str = str.."、";
			end
		end
	end
	self.msgInput.text = str;
end

function Lua_DebugWindow:onTestLaBa(go)
	-- self.msgInput.text = tostring(DataCenter.copyInfoData.script_type);
	local vo = DataCenter.chatData:getSystemChatVoById(1);
	if vo ~= nil and vo:checkCanShow() == true then
		local bv = Lua_BulletinVo.new();
		bv.content = vo.shoutContent;
		bv.priority = 1;
		bv.circle = 1;
		-- Lua_WindowUtil.openWin("Lua_LaBaWindow", WinParam.ACTION_OPEN, bv);
		Lua_WindowUtil.openWin("Lua_LaBaSecWindow", WinParam.ACTION_OPEN, bv);

		local chatVo = Lua_ChatVo.new();
		chatVo.type = Lua_ChatData.CHAT_TYPE_TEXT;
		chatVo.channel = Lua_ChatData.CHANEL_SYSTEM;
		chatVo.role_id = 0;
		chatVo.content = vo.content;
		chatVo.shoutContent = vo.shoutContent;
		DataCenter.chatData:addChatMsg(chatVo);
	end
end

function Lua_DebugWindow:updateLuaFile(go)
	local str = self.msgInput.text;
	if str == nil or str == "" then
		return;
	end

	local arr = string.gsub(str, "^%s*(.-)%s*$", "%1");
	LuaUtil.RefreshLuaFile(arr);
	updateRequire(arr);
	Lua_ProxyManager.updateSingleProxy(arr);
end

function Lua_DebugWindow:dispose()
	if self._isClick ~= nil and self._isClick == true then
		self._isClick = false;
		Lua_CommonUtil.removeTimer(self, self.onDebugDragFrame);
	end
	Lua_TouchControler.getInstance():stopTouchCheck();
	self:superCall("dispose");
end