Lua_MoveTestWindow = class("Lua_MoveTestWindow",Lua_Window)
function Lua_MoveTestWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MoveTestWindow";
	self.skinName = "MoveTestWindow_skin";
	self.isModel = false;
end

function Lua_MoveTestWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.textArea = Lua_TextArea.new(self.content, 350, 200);
	self.textArea:setLocation(-175, 65, 0);
	self.textArea:setText("info");

	self._isClick = false;
	self.dragBg.clickScale = false;
	self.dragBg:addClickFuntion(self, self.onMouseDownHandle);
	self.dragBg:addMouseUpFuntion(self, self.onMouseUpHandle);

	self:addLuaEvent("MOVE_TEST_UPDATE_INFO", self, self.updateInfo);
end

function Lua_MoveTestWindow:onMouseDownHandle(go, state)
    self:onPress(go, true);
end

function Lua_MoveTestWindow:onMouseUpHandle(go, state)
    self:onPress(go, false);
end


function Lua_MoveTestWindow:onPress(go, state)
	if state then
		if self._isClick == false then
			self._isClick = true;
			self.startMouseX = UnityEngine.Input.mousePosition.x;
			self.startMouseY = UnityEngine.Input.mousePosition.y;
			Lua_CommonUtil.addTimer( "onDebugDragFrame", 0.01, self, self.onDebugDragFrame);
		end   
	else
		if self._isClick == true then
			self._isClick = false;
			Lua_CommonUtil.removeTimer(self,self.onDebugDragFrame);
		end
	end
end

function Lua_MoveTestWindow:onDebugDragFrame()
	local dx = UnityEngine.Input.mousePosition.x - self.startMouseX;
	local dy = UnityEngine.Input.mousePosition.y - self.startMouseY;
	self.startMouseX = UnityEngine.Input.mousePosition.x;
	self.startMouseY = UnityEngine.Input.mousePosition.y;

	local vec = self.content.transform.localPosition;
	local targetX = vec.x + dx;
	if targetX < -(MainWinDefine.V_width - self.w) or targetX > (MainWinDefine.V_width - self.w) then
		return;
	end

	local targetY = vec.y + dy;
	if targetY < -(MainWinDefine.V_height - self.h) or targetY > (MainWinDefine.V_height - self.h) then
		return;
	end
	-- self.content.transform.localPosition = Vector3(targetX, targetY, vec.z);
	LuaUtil.setObjPos(self.content, targetX, targetY, vec.z);
end

function Lua_MoveTestWindow:updateInfo()
	self.textArea:setText(DataCenter.MoveTestData);
end

function Lua_MoveTestWindow:dispose()
	if self.textArea ~= nil then
		self.textArea:dispose();
		self.textArea = nil;
	end
	Lua_CommonUtil.removeTimer(self,self.onDebugDragFrame);
	
	self:superCall("dispose");
end